import { Agent } from 'https';
import { connect } from 'tls';
import { Socks5Client } from './client';
export class HttpsAgent extends Agent {
    constructor(options = {}) {
        super();
        const { proxyHost, proxyPort } = options;
        this.socket = new Socks5Client({
            host: proxyHost,
            port: proxyPort,
        });
    }
    createConnection(options) {
        return this.socket.proxyConnect(options, (call) => {
            this.socket.socket = connect({
                servername: options.host,
                socket: this.socket.socket,
            }, () => {
                this.socket.authorized = this.socket.socket.authorized;
                call.call(this.socket);
            });
        });
    }
}
//# sourceMappingURL=HttpsAgent.js.map